/*
Fonksiyon Çizer v0.0.1-d02 Girilen fonksiyonun çizimini yapar.
Bu yazılım hala geliştirme aşamasındadır. Tam olarak kararlı sayılmaz.
Copyright (C) 2004 Engin KUZU
www.enginkuzu.org	enginkuzu@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

//http://www.gnu.org/copyleft/gpl.html
//Turkce cevirisi: http://www.belgeler.org/howto/gpl_copy.html

//
// Fonksiyon Çizer
// v0.01-d02 Engin KUZU
// 3.9.2005 14:31:06
// Girilen fonksiyonu analiz eder, istenilen şekilde çizimini yapar.
// Fonksiyon için izin verilenler işlevler : () + - * / ^ cos() sin() tan() log() x tamsayı(271), kesirli sayılar(1.923).
//

using Gtk;
using Gdk;
using System;

public class FonksiyonCiz
{
	public static Gtk.DrawingArea darea;
	public static bool cizimbos = true; 
	public static Gdk.Pixmap pixmap = null;
	
	public static int en;
	public static int boy;
	
	public static RadioButton rb1;
	
	public static hbox h1;
	public static hbox h2;
	public static hbox h3;
	public static hbox h4;
	
	public static Gtk.SpinButton sb1;
	public static Gtk.SpinButton sb2;

	public static void Main()
	{
		Application.Init ();
		
		Gtk.Window pencere = Yeni_Pencere();
		
		VBox vb = new VBox( false, 5);
		Yeni_Denklemler( vb );
		Yeni_Dugmeler( vb );
		Yeni_Cizim_Alani( vb );
		
		pencere.Add( vb );
		
		pencere.ShowAll();
		Application.Run();
	}
	
	public static Gtk.Window Yeni_Pencere()
	{
		Gtk.Window pencere = new Gtk.Window ("Fonksiyon Çizer");
		pencere.DeleteEvent += new DeleteEventHandler( pencere_kapanma );
		pencere.SizeAllocated += new SizeAllocatedHandler( yeniden_boyutlanma );
		pencere.WindowPosition = Gtk.WindowPosition.Center ;
		pencere.SetSizeRequest(620,600);
		pencere.BorderWidth = 4;
		
		return pencere;
	}
	public static void pencere_kapanma( object o, DeleteEventArgs args)
	{
		Application.Quit();
	}
	public static void yeniden_boyutlanma( object o, SizeAllocatedArgs args)
	{
		Rectangle rec = args.Allocation;
		en = rec.Width - 12;
		boy = rec.Height - 201;
		cizimbos = true;
		//Console.WriteLine ("Size: ({0}, {1})", en, boy);
	}
	public static void Yeni_Denklemler( VBox vb )
	{
		VBox vb2 = new VBox( false, 5);
		
		h1 = new hbox( vb2 ,"1.5*x-3" );
		h2 = new hbox( vb2 ,"(x^3+2*x^2-19*x-20)/23" );
		h3 = new hbox( vb2 ,"4*cos(x)*sin(x)*log((x^2))" );
		h4 = new hbox( vb2 ,"3*sin(2*x)/log((x^2))" );
		
		vb.PackStart( vb2, false, false, 0);
	}
	public static void Yeni_Dugmeler( VBox vb )
	{
		HBox hb1 = new HBox(false,10);
		
		VBox vb1 = new VBox(true,0);
		Button aEkle = new Button("Alan Ekle");
		aEkle.Sensitive = false;
		vb1.PackStart(aEkle, false, false, 0);
		Button aSil = new Button("Alanı Sil");
		aSil.Sensitive = false;
		vb1.PackStart(aSil, false, false, 0);
		hb1.PackStart( vb1, false, false, 0);
		
		
		Frame fr1 = new Frame("Yöntem");
		VBox vb2 = new VBox(true, 0);
		rb1 = new RadioButton("Akıllı Çizim");
		vb2.PackStart( rb1, false, false, 0);
		RadioButton rb2 = new RadioButton(rb1,"Basit Çizim");
		rb2.Active = true;
		vb2.PackStart( rb2, false, false, 0);
		fr1.SetSizeRequest(110,72);
		fr1.Add( vb2 );
		hb1.PackStart(fr1, false, false, 0);
		
		
		Frame fr2 = new Frame("Eksen Değerleri");
		VBox vb3 = new VBox(true,0);
		HBox hb3 = new HBox(true,0);
		Label lbl1 = new Label("X Ekseni : ");
		sb1 = new Gtk.SpinButton(0.1f, 1000f, 0.1f);
		sb1.ValueChanged += new EventHandler( Deger_Degisti );
		sb1.Value = 1.0;
		hb3.PackStart(lbl1, false, false, 0);
		hb3.PackStart(sb1, false, false, 0);
		vb3.PackStart( hb3, false, false, 0);
		
		HBox hb4 = new HBox(true,0);
		Label lbl2 = new Label("Y Ekseni : ");
		sb2 = new Gtk.SpinButton(0.1f, 1000f, 0.1f);
		sb2.ValueChanged += new EventHandler( Deger_Degisti );
		sb2.Value = 1.0;
		hb4.PackStart(lbl2, false, false, 0);
		hb4.PackStart(sb2, false, false, 0);
		vb3.PackStart( hb4, false, false, 0);
		fr2.SetSizeRequest(170,72);
		fr2.Add( vb3);
		hb1.PackStart(fr2, false, false, 0);
		
		
		VBox vb4 = new VBox(true,0);
		Button hesapla = new Button("Hepsini Çiz");
		hesapla.Clicked += new EventHandler( Hepsini_Ciz );
		vb4.PackStart(hesapla, false, false, 0);
		Button cizimiSil = new Button("Çizimi Sil");
		cizimiSil.Clicked += new EventHandler( Ekrani_Sil );
		vb4.PackStart(cizimiSil, false, false, 0);
		hb1.PackEnd(vb4, false, false, 0);

		vb.PackStart( hb1, false, false, 0);
	}
	public static void Deger_Degisti( object o, EventArgs args)
	{
		SpinButton sb = o as SpinButton;
		int degereski = (int)( Math.Round(sb.Value*10) );
		int deger = degereski;
		
		if ( deger == 3 )
			deger = 5;
		else if ( deger == 4 )
			deger = 2;
		else if ( deger == 6 )
			deger = 10;
		else if ( deger == 9 )
			deger = 5;
		else if ( deger == 11 )
			deger = 20;
		else if ( deger == 19 )
			deger = 10;
		else if ( deger == 21 )
			deger = 50;
		else if ( deger == 49 )
			deger = 20;
		else if ( deger == 51 )
			deger = 100;
		else if ( deger == 99 )
			deger = 50;
		else if ( deger == 101 )
			deger = 200;
		else if ( deger == 199 )
			deger = 100;
		else if ( deger == 201 )
			deger = 500;
		else if ( deger == 499 )
			deger = 200;
		else if ( deger == 501 )
			deger = 1000;
		else if ( deger == 999 )
			deger = 500;
		else if ( deger == 1001 )
			deger = 2000;
		else if ( deger == 1999 )
			deger = 1000;
		else if ( deger == 2001 )
			deger = 5000;
		else if ( deger == 4999 )
			deger = 2000;
		else if ( deger == 5001 )
			deger = 10000;
		else if ( deger == 9999 )
			deger = 5000;
			
		sb.Value = deger/10.0;
		
		if ( deger != degereski | deger == 2 | deger == 1)
		{
			Gdk.Rectangle rec = darea.Allocation;
			pixmap.DrawRectangle (darea.Style.WhiteGC, true, 0, 0, rec.Width, rec.Height);
			darea.QueueDraw();
			
			cizimbos = true;
		
			if ( h1.cizildi )
				h1.ciz();
			if ( h2.cizildi )
				h2.ciz();
			if ( h3.cizildi )
				h3.ciz();
			if ( h4.cizildi )
				h4.ciz();
		}
	}
	public static void Ekrani_Sil(object o, EventArgs args)
	{
		Gdk.Rectangle rec = darea.Allocation;
		pixmap.DrawRectangle (darea.Style.WhiteGC, true, 0, 0, rec.Width, rec.Height);
		darea.QueueDraw();
		
		h1.cizildi = false;
		h2.cizildi = false;
		h3.cizildi = false;
		h4.cizildi = false;
	}
	public static void Hepsini_Ciz(object o, EventArgs args)
	{
		h1.ciz();
		h2.ciz();
		h3.ciz();
		h4.ciz();		
	}
	public static void Yeni_Cizim_Alani( VBox vb )
	{
		darea = new Gtk.DrawingArea();
		darea.ExposeEvent += new ExposeEventHandler (ExposeEvent);
		darea.ConfigureEvent += new ConfigureEventHandler (ConfigureEvent);

		Frame fr = new Frame();
		fr.Add( darea );
		vb.PackStart( fr, true, true, 0);
	}
	public static void ExposeEvent(object o, ExposeEventArgs args)
	{
		Gdk.Rectangle rec = args.Event.Area;
		args.Event.Window.DrawDrawable (darea.Style.BlackGC, pixmap,rec.X, rec.Y, rec.X, rec.Y, rec.Width, rec.Height);
		//darea.GdkWindow.DrawDrawable (darea.Style.BlackGC, pixmap,rec.X, rec.Y, rec.X, rec.Y, rec.Width, rec.Height);
		//Console.WriteLine("en : {0} boy : {1}", rec.Width  , rec.Height  );
		
		args.RetVal = false;
	}
	public static void ConfigureEvent (object o, ConfigureEventArgs args)
	{
		Gdk.Window window = args.Event.Window;
		Gdk.Rectangle rec = darea.Allocation;

		pixmap = new Gdk.Pixmap (window, rec.Width, rec.Height, -1);
		pixmap.DrawRectangle (darea.Style.WhiteGC, true, 0, 0, rec.Width, rec.Height);

		args.RetVal = true;
	}


}
